from typing import Optional, Union
from cpl_query.extension.list import List
from parser.model.ast_types_enum import ASTTypesEnum


class AST():

    def __init__(self, type: ASTTypesEnum, value: Union[str, List['AST']], start: Optional[int] = None, end: Optional[int] = None):
        self._type = type
        self._value = value
        self._start = start
        self._end = end

    @property
    def type(self) -> ASTTypesEnum:
        return self._type

    @property
    def value(self) -> Union[str, List['AST']]:
        return self._value

    @property
    def start(self) -> Optional[int]:
        return self._start

    @property
    def end(self) -> Optional[int]:
        return self._end

    def __repr__(self) -> str:
        return f'AST <Type: {self._type}> <Value: {self._value}> <{self._start},{self._end}>'

    def __str__(self) -> str:
        return f'AST <Type: {self._type}> <Value: {self._value}> <{self._start},{self._end}>'
